<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;

class SugestaoVendaItem extends CrudWithParameterBag{
    
    const TABLE = 'SUGESTAOITEM';
    const CAMPO_PK = 'IDSUGESTAOITEM';
    
    protected $dataSourceName = 'confTelaSugestaoVendaItem';
    
    protected $parameterBagColumnsArray = array(
        'filterProd'=> array(
            "NRORG",
            // "IDSUGESTAOTIPO",  // Informa o tipo da sugestão, se é grupo, se é produto, sabor, etc...
            "IDSUGESTAOVENDA" // Produto que tem as sugestões.
        )
    );
    
    protected $novoCodigo;
    protected $dataSourceManager;
    protected $parameterBag;
    protected $util;
     
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, $novoCodigo, $util) {
        $this->novoCodigo  = $novoCodigo;
        $this->util = $util;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $this->parameterBagColumns = $this->parameterBagColumnsArray['filterProd'];
        parent::find($request, $response);
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response){
        $rows = $this->util->getParamsAsArray($request);
        $row = $rows[0];
        
            if(count($row)){
                if($row['IDSUGESTAOTIPO'] == 2){ //QUANDO A SUGESTÃO FOR DO TIPO GRUPO
                    $row['CDSUGESTAOITEM'] = $row['CDGRUPO'];
                    parent::save($this->setCodigo($request,$row),$response);
                } else {
                    // $row['CDPRODUTO']// Vetor de Produtos.
                    if(!is_array($row['CDPRODUTO'])) {
                        $row['CDPRODUTO'] = array($row['CDPRODUTO']);   
                        $row['__is_new'] = false; // Modo de Edição.
                    }    
                    
                    $aux = $row['NRORDEMSUG'];
                    for($i=0; $i < count($row['CDPRODUTO']); $i++) {
                        $row['CDSUGESTAOITEM'] = $row['CDPRODUTO'][$i];
                        $row['NRORDEMSUG'] = $aux + $i;     
                        parent::save($this->setCodigo($request,$row),$response);
                    }
                }   
            }
        }
    
    public function setCodigo ($request, $row){
        if($row['__is_new']){
                $novoCodigo = $this->novoCodigo->getCodeByTableName(self::TABLE,$row['NRORG'],1,null,false);
                $request->getDataSet()->getRows()[0]->set(self::CAMPO_PK, $novoCodigo);
            }
        return $request;
    }
}