<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Factories\RelTempoPermanenciaMesaFactory;

class RelTempoPermanenciaMesaService {
    protected $relTempoPermanenciaMesaFactory;

    public function __construct(RelTempoPermanenciaMesaFactory $relTempoPermanenciaMesaFactory) {
        $this->relTempoPermanenciaMesaFactory = $relTempoPermanenciaMesaFactory;
    }

    public function find($conditions) {
        $result   = [];
        $cdloja   = $conditions['P_CDLOJA'];
        $nrmesa   = $conditions['P_NRMESA'];
        $abertura = isset($conditions['P_DTABERTUR'])?$conditions['P_DTABERTUR']:'';
        $params = [
            'P_CDFILIAL'  => $conditions['P_CDFILIAL'],
            'P_TCDFILIAL' => $conditions['P_TCDFILIAL'],
            'P_TCDLOJA'   => $conditions['P_TCDLOJA'],
            'P_DTINICIAL' => $conditions['P_DTINICIAL'],
            'P_DTFINAL'   => $conditions['P_DTFINAL'],
            'P_TNRMESA'   => $conditions['P_TNRMESA']
        ];
        
        $result = $this->relTempoPermanenciaMesaFactory->find($params, $cdloja, $nrmesa, $abertura);

        return $result;
    }
}